*** transfor.c	2004/05/07 19:46:16	1.1
--- transfor.c	2005/01/16 20:25:17
***************
*** 122,127 ****
--- 125,132 ----
  #endif
  #endif
  #include <stdio.h>
+ #include <stdlib.h>
+ #include <string.h>
  #include <math.h>
  
  #define TRANSFORM
***************
*** 136,142 ****
  #include "multiple.h" /* [GSG 11/9/95] */
  #include "vector.h"   /* [GSG 11/14/95] */
  #include "wbrotate.h" /* [GSG 11/14/95] */
! 
  
  #define CPKMAX  16
  static ShadeRef CPKShade[] = {
--- 141,147 ----
  #include "multiple.h" /* [GSG 11/9/95] */
  #include "vector.h"   /* [GSG 11/14/95] */
  #include "wbrotate.h" /* [GSG 11/14/95] */
! #include "langsel.h"
  
  #define CPKMAX  16
  static ShadeRef CPKShade[] = {
***************
*** 251,256 ****
--- 256,262 ----
                       for(group=chain->glist;group;group=group->gnext)    \
                       for(ptr=group->alist;ptr;ptr=ptr->anext)
  #define ForEachBond  for(bptr=Database->blist;bptr;bptr=bptr->bnext) 
+ #define ForEachSurfBond  for(sbptr=Database->sblist;sbptr;sbptr=sbptr->sbnext)
  #define ForEachBack  for(chain=Database->clist;chain;chain=chain->cnext) \
                       for(bptr=chain->blist;bptr;bptr=bptr->bnext)
  
***************
*** 266,272 ****
      register int max;
  
      max = 0;
!     if( (DrawAtoms || DrawStars) && (MaxAtomRadius>max) )  max = MaxAtomRadius;
      if( DrawBonds && (MaxBondRadius>max) )  max = MaxBondRadius;
         
      temp = ImageRadius + max;
--- 272,279 ----
      register int max;
  
      max = 0;
!     if( (DrawAtoms || DrawStars || DrawSurf) && (MaxAtomRadius>max) )
!       max = MaxAtomRadius;
      if( DrawBonds && (MaxBondRadius>max) )  max = MaxBondRadius;
         
      temp = ImageRadius + max;
***************
*** 284,329 ****
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
  
      if( !Database )
          return;
  
!     irad = (int)(Scale*(Real)(rad));
      MaxAtomRadius = 0;
  	DrawAtoms = False;
  	DrawStars = False; 
       change = False;
  
      ForEachAtom
          if( ptr->flag & SelectFlag )
!         {   if( irad>MaxAtomRadius )
!                 MaxAtomRadius = irad;
! 			if (flag == SphereFlag )
! 			{	ptr->flag |= SphereFlag;
! 				ptr->flag &= ~StarFlag;
! 			} else
! 			{	ptr->flag |= StarFlag;
! 				ptr->flag &= ~SphereFlag;
  			}
              ptr->radius = rad;
              ptr->irad = irad;
              change = True;
          } else if( ptr->flag & SphereFlag )
          {	DrawAtoms = True;
!             if( ptr->irad>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad;
          } else if( ptr->flag & StarFlag )
  		{	DrawStars = True;
!             if( ptr->irad>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad;
          }
  
      if( change )
!     {   if (flag == SphereFlag )
          { DrawAtoms = True;
!         } else { 
!           DrawStars = True;
!         }
          DetermineClipping();
          VoxelsClean = False;
          BucketFlag = False;
--- 291,349 ----
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
+     register int incr;
  
      if( !Database )
          return;
  
!     irad = (int)rint(Scale*(Real)(rad));
!     iProbeRad = (int)rint(Scale*(Real)ProbeRadius);
      MaxAtomRadius = 0;
  	DrawAtoms = False;
  	DrawStars = False; 
+     DrawSurf = False; 
       change = False;
  
      ForEachAtom
+         {  incr = (ptr->flag&ExpandFlag)?iProbeRad:0;
          if( ptr->flag & SelectFlag )
!             {   if( (irad+incr)>MaxAtomRadius )
!                 MaxAtomRadius = irad+incr;
! 		if (flag & SphereFlag )
! 		{  ptr->flag |= SphereFlag|(flag&ExpandFlag);
! 		   ptr->flag &= ~(StarFlag|TouchFlag);
! 		} else if (flag & StarFlag)
! 		{  ptr->flag |= StarFlag|(flag&ExpandFlag);
!                    ptr->flag &= ~(SphereFlag|TouchFlag);
!                 } else if (flag & TouchFlag)
!                 {  ptr->flag |= TouchFlag|(flag&ExpandFlag);
!                    ptr->flag &= ~(SphereFlag|StarFlag);
  			}
              ptr->radius = rad;
              ptr->irad = irad;
              change = True;
          } else if( ptr->flag & SphereFlag )
          {	DrawAtoms = True;
!             if( (ptr->irad+incr)>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad+incr;
          } else if( ptr->flag & StarFlag )
  		{	DrawStars = True;
!             if( (ptr->irad+incr)>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad+incr;
!         } else if( ptr->flag & TouchFlag )
!               {       DrawSurf = True;
!             if( (ptr->irad+incr)>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad+incr;
!         }
          }
  
      if( change )
!     {   if ((flag&SphereFlag) == SphereFlag )
          { DrawAtoms = True;
!         } else if ((flag&StarFlag) == StarFlag )
!         { DrawStars = True;
!         } else
!           DrawSurf = True;
          DetermineClipping();
          VoxelsClean = False;
          BucketFlag = False;
***************
*** 337,342 ****
--- 357,363 ----
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
+     register int incr;
  
      if( !Database )
          return;
***************
*** 345,364 ****
  	DrawAtoms = False;
  	DrawStars = False; 
      change = False;
  
      ForEachAtom
          if( (ptr->flag&SelectFlag) && (ptr->temp>0) )
          {   rad = (5*ptr->temp)>>1;
              if( rad>750 ) rad = 750;
  
!             irad = (int)(Scale*(Real)(rad));
!             if( irad>MaxAtomRadius )
!                 MaxAtomRadius = irad;
  			if (flag == SphereFlag )
! 			{	ptr->flag |= SphereFlag;
  				ptr->flag &= ~StarFlag;
  			} else 
! 			{	ptr->flag |= StarFlag;
  				ptr->flag &= ~SphereFlag;
  			}
              ptr->radius = rad;
--- 366,387 ----
  	DrawAtoms = False;
  	DrawStars = False; 
      change = False;
+     iProbeRad = (int)rint(Scale*(Real)ProbeRadius);
  
      ForEachAtom
+         {  incr = (ptr->flag&ExpandFlag)?iProbeRad:0;
          if( (ptr->flag&SelectFlag) && (ptr->temp>0) )
          {   rad = (5*ptr->temp)>>1;
              if( rad>750 ) rad = 750;
  
!             irad = (int)rint(Scale*(Real)(rad));
!             if( irad+incr>MaxAtomRadius )
!                 MaxAtomRadius = irad+incr;
  			if (flag == SphereFlag )
! 			{	ptr->flag |= SphereFlag|(flag&ExpandFlag);
  				ptr->flag &= ~StarFlag;
  			} else 
! 			{	ptr->flag |= StarFlag|(flag&ExpandFlag);
  				ptr->flag &= ~SphereFlag;
  			}
              ptr->radius = rad;
***************
*** 366,381 ****
              change = True;
          } else if( ptr->flag & SphereFlag )
          {	DrawAtoms = True;
!             if( ptr->irad>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad;
          } else if( ptr->flag & StarFlag )
  		{	DrawStars = True;
!             if( ptr->irad>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad;
          }
  
      if( change )
!     {   if (flag == SphereFlag )
          { DrawAtoms = True;
          } else { 
            DrawStars = True;
--- 389,405 ----
              change = True;
          } else if( ptr->flag & SphereFlag )
          {	DrawAtoms = True;
!             if( (ptr->irad+incr)>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad+incr;
          } else if( ptr->flag & StarFlag )
  		{	DrawStars = True;
!             if( (ptr->irad+incr)>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad+incr;
!         }
          }
  
      if( change )
!     {   if ((flag&SphereFlag) == SphereFlag )
          { DrawAtoms = True;
          } else { 
            DrawStars = True;
***************
*** 400,438 ****
      MaxAtomRadius = 0;
  	DrawAtoms = False;
  	DrawStars = False; 
      change = False;
  
      ForEachAtom
          if( ptr->flag&SelectFlag )
          {   rad = ElemVDWRadius(ptr->elemno);
!             ptr->irad = (int)(Scale*(Real)(rad));
              ptr->radius = rad;
              change = True;
  
! 			if (flag == SphereFlag )
  			{	ptr->flag |= SphereFlag;
! 				ptr->flag &= ~StarFlag;
! 			} else 
  			{	ptr->flag |= StarFlag;
! 				ptr->flag &= ~SphereFlag;
  			}
              if( ptr->irad>MaxAtomRadius )
                  MaxAtomRadius = ptr->irad;
          } else if( ptr->flag & SphereFlag )
!         {	DrawAtoms = True;
!             if( ptr->irad>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad;
          } else if( ptr->flag & StarFlag )
! 		{	DrawStars = True;
!            if( ptr->irad>MaxAtomRadius )
!                 MaxAtomRadius = ptr->irad;
          }
  
      if( change )
!     {   if (flag == SphereFlag )
          { DrawAtoms = True;
!         } else { 
            DrawStars = True;
          }
          DetermineClipping();
          VoxelsClean = False;
--- 424,488 ----
      MaxAtomRadius = 0;
  	DrawAtoms = False;
  	DrawStars = False; 
+     DrawSurf = False; 
      change = False;
  
+     iProbeRad = (int)rint(Scale*(Real)ProbeRadius);
+ 
      ForEachAtom
          if( ptr->flag&SelectFlag )
          {   rad = ElemVDWRadius(ptr->elemno);
!             ptr->irad = (int)rint(Scale*(Real)(rad));
              ptr->radius = rad;
              change = True;
  
! 			if ( flag&SphereFlag )
  			{	ptr->flag |= SphereFlag;
! 				ptr->flag &= ~(StarFlag|TouchFlag);
! 			} else if ( flag&StarFlag )
  			{	ptr->flag |= StarFlag;
! 				ptr->flag &= ~(SphereFlag|TouchFlag);
! 			} else 
!                           {       ptr->flag |= TouchFlag;
!                                   ptr->flag &= ~(SphereFlag | StarFlag);
  			}
+             if (flag&ExpandFlag)
+             {
+               if( (ptr->irad)+iProbeRad>MaxAtomRadius )
+                 MaxAtomRadius = (ptr->irad)+iProbeRad;
+                 ptr->flag |= ExpandFlag;
+             } else {
              if( ptr->irad>MaxAtomRadius )
                  MaxAtomRadius = ptr->irad;
+                 ptr->flag &= ~ExpandFlag;
+             }
          } else if( ptr->flag & SphereFlag )
!         {   int iroff;
!             iroff = (ptr->flag&ExpandFlag)?iProbeRad:0;
!             DrawAtoms = True;
!             if( (ptr->irad)+iroff>MaxAtomRadius )
!                 MaxAtomRadius = (ptr->irad)+iroff;
          } else if( ptr->flag & StarFlag )
!           {   int iroff;
!               iroff = (ptr->flag&ExpandFlag)?iProbeRad:0;
!               DrawStars = True;
!               if( (ptr->irad)+iroff>MaxAtomRadius )
!               MaxAtomRadius = (ptr->irad)+iroff;
!         } else if( ptr->flag & TouchFlag )
!           {   int iroff;
!               iroff = (ptr->flag&ExpandFlag)?iProbeRad:0;
!               DrawSurf = True;
!               if( (ptr->irad)+iroff>MaxAtomRadius )
!               MaxAtomRadius = (ptr->irad)+iroff;
          }
  
      if( change )
!     {   if ((flag&SphereFlag) == SphereFlag )
          { DrawAtoms = True;
!         } else if ((flag&StarFlag) == StarFlag ) { 
            DrawStars = True;
+         } else if ((flag&TouchFlag) == TouchFlag ) { 
+           DrawSurf = True;
          }
          DetermineClipping();
          VoxelsClean = False;
***************
*** 446,451 ****
--- 496,502 ----
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
+     register int incr;
  
      if( !Database )
          return;
***************
*** 453,475 ****
      MaxAtomRadius = 0;
      DrawAtoms = False;
      DrawStars = False;
      
      ForEachAtom
          if( !(ptr->flag&SelectFlag) )
          {   if( ptr->flag&SphereFlag )
!             {   if( ptr->irad>MaxAtomRadius )
!                     MaxAtomRadius = ptr->irad;
                  DrawAtoms = True;
              } 
              if( ptr->flag&StarFlag )
!             {   if( ptr->irad>MaxAtomRadius )
!                     MaxAtomRadius = ptr->irad;
                  DrawStars = True;
              }
!         } else if( ptr->flag&SphereFlag || ptr->flag&StarFlag )
            {
!             ptr->flag &= ~SphereFlag;
!             ptr->flag &= ~StarFlag;
            }
  
      DetermineClipping();
--- 504,537 ----
      MaxAtomRadius = 0;
      DrawAtoms = False;
      DrawStars = False;
+     DrawSurf  = False;
+     iProbeRad = (int)rint(Scale*(Real)ProbeRadius);    
      
      ForEachAtom
+         {  incr = (ptr->flag&ExpandFlag)?iProbeRad:0;
          if( !(ptr->flag&SelectFlag) )
          {   if( ptr->flag&SphereFlag )
!             {   if( (ptr->irad+incr)>MaxAtomRadius )
!                     MaxAtomRadius = ptr->irad+incr;
                  DrawAtoms = True;
              } 
              if( ptr->flag&StarFlag )
!             {   if( (ptr->irad+incr)>MaxAtomRadius )
!                     MaxAtomRadius = ptr->irad+incr;
                  DrawStars = True;
              }
!             if( ptr->flag&TouchFlag )
!             {   if( (ptr->irad+incr)>MaxAtomRadius )
!                     MaxAtomRadius = ptr->irad+incr;
!                 DrawSurf = True;
!             }
!         } else if( ptr->flag&SphereFlag ||
!                    ptr->flag&StarFlag ||
!                    ptr->flag&TouchFlag ||
!                    ptr->flag&ExpandFlag )
            {
!             ptr->flag &= ~(SphereFlag|StarFlag|TouchFlag|ExpandFlag);
!           }
            }
  
      DetermineClipping();
***************
*** 492,500 ****
  
      DrawBonds = False;
      MaxBondRadius = 0;
!     irad = (int)(Scale*(Real)(rad));
      if ( arad < rad ) {
!       iarad = (int)(Scale*(Real)(arad));
      } else {
        iarad = irad;
      }
--- 554,562 ----
  
      DrawBonds = False;
      MaxBondRadius = 0;
!     irad = (int)rint(Scale*(Real)(rad));
      if ( arad < rad ) {
!       iarad = (int)rint(Scale*(Real)(arad));
      } else {
        iarad = irad;
      }
***************
*** 533,539 ****
  		starrad = 75;
  	  else
  		starrad = (int) (1.5*rad);
!       istarrad = (int)(Scale*(Real)(starrad));
        change = False;
        ForEachAtom
        { if ( (ptr->flag & SelectFlag) &&
--- 595,601 ----
  		starrad = 75;
  	  else
  		starrad = (int) (1.5*rad);
!       istarrad = (int)rint(Scale*(Real)(starrad));
        change = False;
        ForEachAtom
        { if ( (ptr->flag & SelectFlag) &&
***************
*** 603,611 ****
      if( !Database )
          return;
  
!     irad = (int)(Scale*(Real)(rad));
      if ( arad < rad ) {
!       iarad = (int)(Scale*(Real)(arad));
      } else {
        iarad = irad;
      }
--- 665,673 ----
      if( !Database )
          return;
  
!     irad = (int)rint(Scale*(Real)(rad));
      if ( arad < rad ) {
!       iarad = (int)rint(Scale*(Real)(arad));
      } else {
        iarad = irad;
      }
***************
*** 672,680 ****
          list = Database->slist;
      }
  
!     irad = (int)(Scale*(Real)(rad));
      if ( arad < rad ) {
!       iarad = (int)(Scale*(Real)(arad));
      } else {
        iarad = irad;
      }
--- 734,742 ----
          list = Database->slist;
      }
  
!     irad = (int)rint(Scale*(Real)(rad));
      if ( arad < rad ) {
!       iarad = (int)rint(Scale*(Real)(arad));
      } else {
        iarad = irad;
      }
***************
*** 906,911 ****
--- 968,974 ----
  void SelectArea( int mode, int count, int xo, int yo, int x, int y )
  {
      register Bond __far *bptr;
+ 	register SurfBond __far *sbptr;
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
***************
*** 972,982 ****
  	           if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
  	           {   bptr->flag |= SelectFlag;
  	           } else bptr->flag &= ~SelectFlag;
! 	    } else
  	        ForEachBond
  	           if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
  	           {   bptr->flag |= SelectFlag;
  	           } else bptr->flag &= ~SelectFlag;
  		DisplaySelectCount();
  	} else {	/*Go fast for quick redraw*/
  		if( mode==0 )
--- 1035,1054 ----
  	           if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
  	           {   bptr->flag |= SelectFlag;
  	           } else bptr->flag &= ~SelectFlag;
! 	        ForEachSurfBond
! 	           if( (sbptr->srcatom->flag&sbptr->dstatom->flag) & SelectFlag )
! 	           {   sbptr->flag |= SelectFlag;
! 	           } else sbptr->flag &= ~SelectFlag;
! 	    } else {
  	        ForEachBond
  	           if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
  	           {   bptr->flag |= SelectFlag;
  	           } else bptr->flag &= ~SelectFlag;
+ 	        ForEachSurfBond
+ 	           if( (sbptr->srcatom->flag|sbptr->dstatom->flag) & SelectFlag )
+ 	           {   sbptr->flag |= SelectFlag;
+ 	           } else sbptr->flag &= ~SelectFlag;
+ 	    }
  		DisplaySelectCount();
  	} else {	/*Go fast for quick redraw*/
  		if( mode==0 )
***************
*** 1000,1005 ****
--- 1072,1078 ----
  void SelectZone( int mask )
  {
      register Bond __far *bptr;
+     register SurfBond __far *sbptr;
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
***************
*** 1020,1037 ****
             if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
!     } else
          ForEachBond
             if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
! 
  }
  
  
  void RestrictZone( int mask )
  {
      register Bond __far *bptr;
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
--- 1093,1125 ----
             if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
!         ForEachSurfBond
!            if( (sbptr->srcatom->flag&sbptr->dstatom->flag) & SelectFlag )
!            {   sbptr->flag |= SelectFlag;
!                DrawSurf = True;
!                sbptr->dstatom->flag |= TouchFlag;
!                sbptr->srcatom->flag |= TouchFlag;
!            } else sbptr->flag &= ~SelectFlag;
!     } else {
          ForEachBond
             if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
!          ForEachSurfBond
!            if( (sbptr->srcatom->flag|sbptr->dstatom->flag) & SelectFlag )
!            {   sbptr->flag |= SelectFlag;
!                DrawSurf = True;
!                sbptr->dstatom->flag |= TouchFlag;
!                sbptr->srcatom->flag |= TouchFlag;
!            } else sbptr->flag &= ~SelectFlag;
!     }
  }
  
  
  void RestrictZone( int mask )
  {
      register Bond __far *bptr;
+     register SurfBond __far *sbptr;
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
***************
*** 1042,1047 ****
--- 1130,1136 ----
  
      DrawAtoms = False;   MaxAtomRadius = 0;
      DrawStars = False;
+     DrawSurf = False;
      DrawBonds = False;   MaxBondRadius = 0;
      
      SelectCount = 0;
***************
*** 1060,1067 ****
                  if( ptr->irad>MaxAtomRadius )
                      MaxAtomRadius = ptr->irad;
              }
          } else 
!         {   ptr->flag &= ~(SelectFlag|SphereFlag|StarFlag);
              if( ptr->label )
              {   DeleteLabel( (Label*)ptr->label );
                  ptr->label = (void*)0;
--- 1149,1165 ----
                  if( ptr->irad>MaxAtomRadius )
                      MaxAtomRadius = ptr->irad;
              }
+             if( ptr->flag & TouchFlag )
+             {   DrawSurf = True;
+                 if( ptr->irad>MaxAtomRadius )
+                      MaxAtomRadius = ptr->irad;
+             }
+             if( ptr->flag & ExpandFlag )
+             {  if( (ptr->irad)+iProbeRad > MaxAtomRadius )
+                    MaxAtomRadius = (ptr->irad)+iProbeRad;
+             }
          } else 
!         {   ptr->flag &= ~(SelectFlag|SphereFlag|StarFlag|TouchFlag|ExpandFlag);
              if( ptr->label )
              {   DeleteLabel( (Label*)ptr->label );
                  ptr->label = (void*)0;
***************
*** 1082,1087 ****
--- 1180,1196 ----
              } 
          } else bptr->flag &= ~(SelectFlag|DrawBondFlag);
      }
+     
+     ForEachSurfBond
+     {   /* Ignore ZoneBoth setting! */
+         flag = sbptr->dstatom->flag & sbptr->srcatom->flag;
+         if( flag & SelectFlag )
+         {   sbptr->flag |= SelectFlag;
+             DrawSurf = True;
+             sbptr->dstatom->flag |= TouchFlag;
+             sbptr->srcatom->flag |= TouchFlag;
+         } else sbptr->flag &= ~(SelectFlag);
+     }
  
      ForEachBack
      {   /* Ignore ZoneBoth setting! */
***************
*** 1116,1121 ****
--- 1225,1231 ----
  void SelectZoneExpr( Expr *expr )
  {
      register Bond __far *bptr;
+     register SurfBond __far *sbptr;
      register AtomSet __far *pset;
  	register int i;
  
***************
*** 1156,1172 ****
             if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
!     } else
          ForEachBond
             if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
!            } else bptr->flag &= ~SelectFlag;
  }
  
  
  void RestrictZoneExpr( Expr *expr )
  {
      register Bond __far *bptr;
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
--- 1266,1293 ----
             if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
!         ForEachSurfBond
!            if( (sbptr->srcatom->flag&sbptr->dstatom->flag) & SelectFlag )
!            {   sbptr->flag |= SelectFlag;
!            } else sbptr->flag &= ~SelectFlag;
!     } else 
!     {
          ForEachBond
             if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
!            } else bptr->flag &= ~SelectFlag;	
!         ForEachSurfBond
!            if( (sbptr->srcatom->flag|sbptr->dstatom->flag) & SelectFlag )
!            {   sbptr->flag |= SelectFlag;
!            } else sbptr->flag &= ~SelectFlag;
!     }
  }
  
  
  void RestrictZoneExpr( Expr *expr )
  {
      register Bond __far *bptr;
+     register SurfBond __far *sbptr;
      register Chain __far *chain;
      register Group __far *group;
      register RAtom __far *ptr;
***************
*** 1197,1204 ****
                          if( QAtom->irad>MaxAtomRadius )
                              MaxAtomRadius = QAtom->irad;
                      }
                  }  else 
!                 {   QAtom->flag &= ~(SelectFlag|SphereFlag|StarFlag);
                      if( QAtom->label )
                      {   DeleteLabel( (Label*)QAtom->label );
                          QAtom->label = (void*)0;
--- 1318,1331 ----
                          if( QAtom->irad>MaxAtomRadius )
                              MaxAtomRadius = QAtom->irad;
                      }
+                     if( QAtom->flag & ExpandFlag )
+                     {   if( (QAtom->irad)+iProbeRad>MaxAtomRadius )
+                             MaxAtomRadius = (QAtom->irad)+iProbeRad;
+                     }
+ 
                  }  else 
!                 {   QAtom->flag &=
!                         ~(SelectFlag|SphereFlag|StarFlag|ExpandFlag);
                      if( QAtom->label )
                      {   DeleteLabel( (Label*)QAtom->label );
                          QAtom->label = (void*)0;
***************
*** 1219,1224 ****
--- 1346,1363 ----
                  DrawBonds = True;
          } else bptr->flag &= ~(SelectFlag|DrawBondFlag);
      }
+     
+     ForEachSurfBond
+     {   /* Ignore ZoneBoth setting! */
+         flag = sbptr->dstatom->flag & sbptr->srcatom->flag;
+         if( flag & SelectFlag )
+         {   sbptr->flag |= SelectFlag;
+             DrawSurf = True;
+             sbptr->dstatom->flag |= TouchFlag;
+             sbptr->srcatom->flag |= TouchFlag;
+         } else sbptr->flag &= ~(SelectFlag);
+     }
+ 
  
      ForEachBack
      {   /* Ignore ZoneBoth setting! */
***************
*** 1251,1256 ****
--- 1390,1396 ----
  
  void SelectAtom( int shift, RAtom __far *PAtom, Group __far *PGroup )
  {	register Bond __far *bptr;
+     register SurfBond __far *sbptr;
  	
  	SelectCount = 0;
  	for( QChain=Database->clist; QChain; QChain=QChain->cnext )
***************
*** 1283,1297 ****
  		if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
! 	} else
!         ForEachBond
!            if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
!            {   bptr->flag |= SelectFlag;
!            } else bptr->flag &= ~SelectFlag;
  }
  
  void SelectGroup( int shift, Group __far *PGroup )
  {	register Bond __far *bptr;
  
  	SelectCount = 0;
  	for( QChain=Database->clist; QChain; QChain=QChain->cnext )
--- 1423,1440 ----
  		if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
! 	} else {
! 	    ForEachSurfBond
!         if( (sbptr->srcatom->flag|sbptr->dstatom->flag) & SelectFlag )
!            {  sbptr->flag |= SelectFlag;
!            } else sbptr->flag &= ~SelectFlag;
! 
! 	}
  }
  
  void SelectGroup( int shift, Group __far *PGroup )
  {	register Bond __far *bptr;
+     register SurfBond __far *sbptr;
  
  	SelectCount = 0;
  	for( QChain=Database->clist; QChain; QChain=QChain->cnext )
***************
*** 1321,1335 ****
  		if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
! 	} else
          ForEachBond
             if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
!            } else bptr->flag &= ~SelectFlag;
  }
  
  void SelectChain( int shift, Chain __far *PChain )
  {	register Bond __far *bptr;
  
  	SelectCount = 0;
  	for( QChain=Database->clist; QChain; QChain=QChain->cnext )
--- 1464,1488 ----
  		if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
!         ForEachSurfBond
! 		if( (sbptr->srcatom->flag&sbptr->dstatom->flag) & SelectFlag )
!            {   sbptr->flag |= SelectFlag;
!            } else sbptr->flag &= ~SelectFlag;
! 	} else {
          ForEachBond
             if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
!            } else bptr->flag &= ~SelectFlag;		
!         ForEachSurfBond
!            if( (sbptr->srcatom->flag|sbptr->dstatom->flag) & SelectFlag )
!            {   sbptr->flag |= SelectFlag;
!            } else sbptr->flag &= ~SelectFlag;		
! 	}
  }
  
  void SelectChain( int shift, Chain __far *PChain )
  {	register Bond __far *bptr;
+     register SurfBond __far *sbptr;
  
  	SelectCount = 0;
  	for( QChain=Database->clist; QChain; QChain=QChain->cnext )
***************
*** 1359,1369 ****
  		if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
! 	} else
          ForEachBond
             if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
!            } else bptr->flag &= ~SelectFlag;
  }
  
  
--- 1512,1531 ----
  		if( (bptr->srcatom->flag&bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
             } else bptr->flag &= ~SelectFlag;
!         ForEachSurfBond
! 		if( (sbptr->srcatom->flag&sbptr->dstatom->flag) & SelectFlag )
!            {   sbptr->flag |= SelectFlag;
!            } else sbptr->flag &= ~SelectFlag;
! 	} else {
          ForEachBond
             if( (bptr->srcatom->flag|bptr->dstatom->flag) & SelectFlag )
             {   bptr->flag |= SelectFlag;
!            } else bptr->flag &= ~SelectFlag;	
!         ForEachSurfBond
!            if( (sbptr->srcatom->flag|sbptr->dstatom->flag) & SelectFlag )
!            {   sbptr->flag |= SelectFlag;
!            } else sbptr->flag &= ~SelectFlag;
! 	}
  }
  
  
***************
*** 2385,2391 ****
  
          if( fields & MaskRadiusFlag )
          {   rad = match? mptr->radius : 375;
!             ptr->irad = (int)(Scale*(Real)(rad));
              ptr->flag |= SphereFlag;
              ptr->radius = rad;
  
--- 2547,2553 ----
  
          if( fields & MaskRadiusFlag )
          {   rad = match? mptr->radius : 375;
!             ptr->irad = (int)rint(Scale*(Real)(rad));
              ptr->flag |= SphereFlag;
              ptr->radius = rad;
  
***************
*** 2394,2400 ****
              change = True;
          }
      } else 
!     {   if( ptr->flag & SphereFlag )
          {   DrawAtoms = True;
          if( ptr->irad>MaxAtomRadius )
              MaxAtomRadius = ptr->irad;
--- 2556,2562 ----
              change = True;
          }
      } else 
!     {   if( ptr->flag & (SphereFlag|TouchFlag|ExpandFlag) )
          {   DrawAtoms = True;
          if( ptr->irad>MaxAtomRadius )
              MaxAtomRadius = ptr->irad;
***************
*** 2404,2409 ****
--- 2566,2581 ----
          if( ptr->irad>MaxAtomRadius )
              MaxAtomRadius = ptr->irad;
          }
+         if( ptr->flag & TouchFlag )
+         {   DrawSurf = True;
+         if( ptr->irad>MaxAtomRadius )
+             MaxAtomRadius = ptr->irad;
+         }
+         if( ptr->flag & ExpandFlag )
+         {
+           if( (ptr->irad)+iProbeRad>MaxAtomRadius )
+             MaxAtomRadius = (ptr->irad)+iProbeRad;
+         }
       }
  
      if( change )
***************
*** 2803,2809 ****
  
  }
  
! void RMat2RV( Real *RX, Real *RY, Real *RZ, 
    Real RMX[3], Real RMY[3], Real RMZ[3]  ) {
    
    Real SRX, SRY, SRZ, TRX, TRY, TRZ;
--- 2975,2981 ----
  
  }
  
! void RMat2RV( Real __far *RX, Real __far *RY, Real __far *RZ, 
    Real RMX[3], Real RMY[3], Real RMZ[3]  ) {
    
    Real SRX, SRY, SRZ, TRX, TRY, TRZ;
***************
*** 2892,2915 ****
       
      } 
  
!     LOffset[0] = WRange + (int)(Zoom*DialValue[DialTX]*XRange);
!     LOffset[1] = HRange + (int)(Zoom*DialValue[DialTY]*YRange);
!     LOffset[2] = 10000 + (int)(Zoom*DialValue[DialTZ]*ZRange);
          
  
      if ( ( DialValue[DialRX] != LastRX ) || 
           ( DialValue[DialRY] != LastRY ) ||
           ( DialValue[DialRZ] != LastRZ ) ) {
           
- /*      RV2RMat(DialValue[DialRX]-LastRX, 
-         DialValue[DialRY]-LastRY, 
-         DialValue[DialRZ]-LastRZ,
-         NRotX, NRotY, NRotZ);
- 
-       RV2RMat(LastRX, LastRY, LastRZ,
-         RMat[0], RMat[1], RMat[2]);
-   */
-   
        RV2RMat(DialValue[DialRX]-LastRX,
          DialValue[DialRY]-LastRY,
          DialValue[DialRZ]-LastRZ,
--- 3064,3078 ----
       
      } 
  
!     LOffset[0] = WRange + (int)rint(Zoom*DialValue[DialTX]*XRange);
!     LOffset[1] = HRange + (int)rint(Zoom*DialValue[DialTY]*YRange);
!     LOffset[2] = 10000 + (int)rint(Zoom*DialValue[DialTZ]*ZRange);
          
  
      if ( ( DialValue[DialRX] != LastRX ) || 
           ( DialValue[DialRY] != LastRY ) ||
           ( DialValue[DialRZ] != LastRZ ) ) {
           
        RV2RMat(DialValue[DialRX]-LastRX,
          DialValue[DialRY]-LastRY,
          DialValue[DialRZ]-LastRZ,
